// JavaScript Document
/* --------------------------------------------------------------------
** This script is a common search function implementor for DHTMLXGrid
*
*   @Author - Channa Dewamitta
*   @Date   - 12/02/2013
*   @Last Modified - 02/05/2013
*   @Last Modification - Added support for DHTMLX Auto pagination enabled
*                         grid support
*   @Version - 1.0.1
*----------------------------------------------------------------------*/

var debug = true;        //set to tre when debugging
function searchColumnObj(){
  this.name = '';
  this.id = '';
  this.style = '';
  this.size = '5';
  this.maxlength = '';
  this.placeholder = '';
  this.type = '';   //'text','bool','selection','number',filler'
  
}

function searchObj(){ 
  this.grid = '';
  this.gridVarName = '';
  this.toolbar = '';
  this.toolbarVarName ='' ;
  this.workbenchVarName ='' ;
  this.objIdB4Spacer = '';
  this.searchVarName = '';
  this.toggleState = false;
  this.filterUrl = '';
  this.XMLUrl = '';
  this.columns = [] ;
  
  //methods
  this.creatHeader = function(){
      var myHeader ='';
      var count=0; 
      for ( var column in this.columns){ 
        var mycolumn = this.columns[column];

         switch (mycolumn.type) { 
             case 'text':         //Create Text type search fields
              myHeader +=  '<div class="layer1"><input type="text" size="'+mycolumn.size +'" id="'+mycolumn.id+'" name="'+mycolumn.name+'" class="searchfield" onKeyUp="parent.'+this.searchVarName+'.reloadGrid()" placeholder="'+mycolumn.placeholder+'" style="'+mycolumn.style+'"></div>,';
              break;
            case 'bool':          //Create bool type search fieds (All/Yes/No)
              myHeader +=  '<div class="layer1"><select id="'+mycolumn.id+'" name="'+mycolumn.name+'" class="searchfield placeHolder" onChange="{dullColor(this);'+this.searchVarName+'.reloadGrid()}" placeholder="'+mycolumn.placeholder+'"><option value="" selected="selected" class="placeHolder">All</option><option value="1">Yes</option><option value="-1">No</option></select></div>,';
              break;
            case 'selection':    //Create selection type filters
              //TO BE DONE
              break;
            case 'number':       //Create Number/Value type search filters
              //TO BE DONE
              break;
            case 'filler':       //Create Fillers (#rspans)
              myHeader += '#rspan,';
              break;
         }
         count=count+1;
      }
      myHeader = myHeader.substring(0,(myHeader.length-1)); //Remove trailing ','
      if (debug) console.log('myHeader is :-',myHeader);
      return myHeader;
  }
  
  this.toggleSearch = function (){
    this.toggleState = !this.toggleState
    if (this.toggleState) {
      this.toolbar.setItemImage('search','find_dis.png'); //Set difused image
      var tempHeader =  this.creatHeader();
      this.grid.attachHeader(tempHeader);
      this.toolbar.setItemImage('refresh','reset_dis.png');
    } else { 
      if (this.grid._aHead == undefined) {
        this.grid.detachHeader(1);
      }else {
        this.grid.detachHeader(this.grid._aHead);   //remove search header  
      }
      if (this.XMLUrl.length ==0) this.XMLUrl = this.grid.xmlFileurl ;
      
      this.toolbar.setItemImage('search','find.png');   //set to active image
      this.toolbar.setItemImage('refresh','reset.png');
      this.filterUrl = ''; //alert('File URL is :-'+ this.grid.xmlFileUrl)  ;
      //-----------------------------------------
      var myUrl = this.grid.xmlFileUrl == '' ? this.XMLUrl : this.grid.xmlFileUrl;
      //If DHTMLX Auto pagination is active w need to remove the querry string
      //that is embedded in the xmlFileUrl. WCD 02/05/13
      var queryStart = myUrl.indexOf('?');
      myUrl = queryStart < 0 ? myUrl : myUrl.substr(0,queryStart);
      //---End pagination support----
      myUrl = myUrl.replace('/true/','/false/','gi')
      this.grid.clearAndLoad(myUrl); 
      //-----------------------------------------
      //this.grid.clearAndLoad(this.grid.xmlFileUrl);
      //this.grid.clearAndLoad(this.XMLUrl);
    }
    this.grid.render_dataset();       //Show the added/removed Header
  }

  this.init = function () {
    //We need to do more here. Have to find out the current status and then
    //add the button to the left corner . This was don in the following way WCD
    if (debug) console.log('Sarch object is :-'+ this);
     //this.toolbar.addSpacer('spcSearch');
    if (this.toolbar._spacer === undefined) {
     if (this.objIdB4Spacer === '') {
      this.objIdB4Spacer = 'sepSearch98' ;
      this.toolbar.addSeparator(this.objIdB4Spacer,98);
     }
     this.toolbar.addSpacer(this.objIdB4Spacer);
     //this.toolbar.removeItem('sepSearch98')
    }
    
    if (this.toolbar._spacer === undefined) this.toolbar.addSpacer('spcSearch');
    this.toolbar.addSeparator('sepSearch',99);
    this.toolbar.addButton('search',100,'Search','find.png','find_dis.png'); 
    this.toolbar.setItemToolTip('search','Activate/Deactivate data search');
  }
  
  this.addColumn = function (mycolumn){
    if (!mycolumn) {
      mycolumn = new searchColumnObj();
      mycolumn.name = 'col' + (this.columns.length + 1);
    }
    this.columns[mycolumn.name]= mycolumn;
  }

}

searchObj.prototype = {
  reloadGrid: function (){ 
    //build filter url
    this.filterUrl = '';  
    var myinput;
    var inputs = document.getElementsByClassName('searchfield') ;

    for (var myinput in inputs) {
      if (debug) console.log('input :-'+inputs[myinput].name);
      if (inputs[myinput].value !='' && inputs[myinput].value != null ) {
         //this.filterUrl += inputs[myinput].name + '=' + inputs[myinput].value + '&'; 
         //We need to do some more work here
         this.filterUrl += inputs[myinput].name + '_like' + '=' + inputs[myinput].value + '&'; 
      }
    }
    this.filterUrl = this.filterUrl.substring(0,(this.filterUrl.length-1))  //remove extra '&'
    this.filterUrl += this.filterUrl.length > 0? '&filtersOn=true':'filtersOn=true';       //For stopping xml column heades
   
    //var myUrl = this.grid.xmlFileUrl == '' ? this.XMLUrl : this.grid.xmlFileUrl;
    var myUrl = this.grid.xmlLoader.filePath //WCD 07/05/2013
    
    if (debug) console.log('myUrl is ;-'+myUrl);
    //If DHTMLX Auto pagination is active w need to remove the querry string
    //that is embedded in the xmlFileUrl. WCD 02/05/13
    var queryStart = myUrl.indexOf('?');
    myUrl = queryStart < 0 ? myUrl : myUrl.substr(0,queryStart);
    //---End pagination support----
    myUrl = myUrl.replace('/false/','/true/','gi') 
    if (debug) console.log('xmlUrl is :- ',myUrl + '?'+this.filterUrl);
    this.grid.clearAndLoad(myUrl + '?'+this.filterUrl);
    //this.grid.clearAndLoad(this.grid.xmlFileUrl  + '?'+this.filterUrl);
    //this.grid.clearAndLoad(this.XMLUrl + '?'+this.filterUrl);
  }
}

//this function handles a display effects of the dropdown when default item is
//selected  (Grayed)
function dullColor(me){
  if (me.value) {
    me.style.color='#000000';
  }else {
    me.style.color='#6D6D6D';
  }
}