/*
 * This is a reusable toolbar object. 
 **/

function toolbarObj() {

/* user can specify for which compoment the toolbar is going to use.
 * the compoment can be a grid or form. depending on which compoment is going to use
 * the default set of items will be different.Fore example if the component is grid then toolbar
 * will have items like add, edit, delete and if the component is form the toolbar should have 
 * save, cancel and reset buttons.
 * If user doesnt specify a component this will use 'grid' as the component
 * */
this.component=""

//user can set icon path. If not default icon path will be used
this.iconpath="";

//Bool : set whether default items are having or not
//if this is not set it will take as a true.(will have default)
this.defaultitems="";

//ID Array: set of items which should be disabled at the loading
//if this is not set, no diable items in the toolbar
this.disabled = "";

//this is an array of item objects which user pass to have except default items. 
// If this.defaultitems=false then toolbar will be created without default items and only use this items.
//If this is not set, only default items will be created
this.items = "";

//ID Array : set of items which should not be added(can be used when the use wants to have only few items from defaultitems)
this.notSet="";

this.attachform="";
this.attachformwidth="";
this.gridreloadurl ="";
this.form="";
this.formUrl='';

var toolbarxml;
var toolbar;

var defaultForGrid =[{id:'add',type:'button',img:'add.png',imgdis:'add_dis.gif',text:'Add'},
                     {id:'edit',type:'button',img:'edit.png',imgdis:'edit_dis.png',text:'Edit'},
                     {id:'delete',type:'button',img:'delete.png',imgdis:'delete_dis.png',text:'Delete'},
                     {id:'refresh',type:'button',img:'reset.png',imgdis:'reset_dis.png',text:'Refresh'}];


var defaultForForm =[{id:'save',type:'button',img:'save.gif',imgdis:'save_dis.gif',text:'Save'},
                     {id:'reset',type:'button',img:'reset.png',imgdis:'reset_dis.png',text:'Reset'},
                    // {id:'cancel',type:'button',img:'cancel.png',imgdis:'cancel_dis.gif',text:'Cancel'},
                     {id:'close',type:'button',img:'close.png',imgdis:'close_dis.png',text:'Close'}];


this.createXml = function(){
      
      toolbarxml  = '<?xml version="1.0" encoding="UTF-8"?>';
      toolbarxml += '<toolbar>'; 

      if(this.component=='grid') {
          var itemsArray= defaultForGrid;
      }else if(this.component=='form'){          
          var itemsArray= defaultForForm;
      }else {
          var itemsArray= defaultForGrid; 
      }
    
      if(this.defaultitems!=false) { //check whether the default items are going to use
               for(i=0; i< itemsArray.length; i++){
                   var ignore=this.notSet.indexOf(itemsArray[i].id); //check the id is in notSet array
                   if(ignore==-1) { //pass -1 if the id is not in array.If so good to go..
                       var id=itemsArray[i].id;                      
                       var type=itemsArray[i].type;
                       var img=itemsArray[i].img;    
                       var text=itemsArray[i].text;   
                       var index = this.disabled.indexOf(id);
                       var imgdis=itemsArray[i].imgdis;
                       if(index!=-1) { //if the id is in disable item array....
                             var disable = true;
                       }else {
                             var disable = false;
                       }
                       //Add disabled image in any case. WCD 30/09/15
                       toolbarxml += '<item id="'+id+'" type="'+type+'"   img="'+img+'"  text="'+text+'" imgdis="'+imgdis+'"';
                       if(disable==true) {
                          toolbarxml += ' enabled="false"';
                        }
                        toolbarxml += '/>'; 
                        toolbarxml += '<item id="sep'+id+'" type="separator" />'  ;  
                   }
               }
      }    
      if(this.items!="") {
          for(i=0; i< this.items.length; i++){
                   var ignore=this.notSet.indexOf(id); //check the id is in notSet array
                   if(ignore==-1) { //pass -1 if the id is not in array.If so good to go..
                       var id=this.items[i].id;
                       var type=this.items[i].type;
                       var img=this.items[i].img;    
                       var text=this.items[i].text;   
                       var index = this.disabled.indexOf(id);
                       var imgdis=this.items[i].imgdis;
                       if(index!=-1) { //if the id is in disable item array....
                             var disable = true;
                       }
                       //Add disabled image in any case. WCD 30/09/15
                       toolbarxml += '<item id="'+id+'" type="'+type+'"   img="'+img+'"  imgdis="'+imgdis+'" text="'+text+'"';
                       if(disable==true) {
                          toolbarxml += ' enabled="false"';
                        }
                        toolbarxml += '/>';
                         toolbarxml += '<item id="sep'+id+'" type="separator" />'  ;     
                   }
               }
      }
      toolbarxml += '</toolbar>'; 

      return toolbarxml;
      
} 

this.init = function () {
    this.createXml();
}

}