// JavaScript Document
/* --------------------------------------------------------------------
** This script is a common search function implementor for DHTMLXGrid
*  Works with or without workbench. Works with standard EKWA CIGEN 
*  generated backend controlers and models.
*  
*  @USAGE - create the grid first as per the DHTMLX specifications
*  			create the search object like
*  
*  			var mysearchobj = new searchObj();
*  
*  			and then search columns as an
*  			array of searchColumnObj objects like;
*  
*  			var myColumns = [];
*  			myColumns[0] = new searchColumnObj();
*  			myColumns[0].type='text' //could be bool,selection,date, 
*  				number or filler (Filler= no search field is added but
*  				just fills the gap)
*  			myColumn[0].name = 'table-field-name' //(if ambiguas column
*  				names are there preppend field name with table alias 
*  				and a '/'
*  			myColumn[0].id = 'myid' //input field id
*  			myColumn[0].style = 'color:red;font-size:12pt' //valid style
*  				string
*  			myColumn[0].size = '10' //display size of the input field (not
*  				applicable for field types selection,bool & date)
*  			myColumn[0].maxlength = '10' //Maximum input length (not 
*  				applicable for field types bool,selection and date)
*  			myColumn[0].placeholder = 'Enter a name' //Descriptive text for
*  				input field as a placeholder
*  			myColumn[0].title = 'Type name here' //Instructions to
*  				user as hover text
*  			myColumn[0].options=[['Option 1','value1'],['Option 2',
*  				'value2]] //For selection type columns only
*  			mysearchobj.columns.push(myColumn);
*  
*  			the above should be repeated for each column in order with 
*  			filler columns for non serchable columns
*  
*  			or alternaly you may create as
*  
*  			var myColumns = [{type:'text',name:'table-field-name',
*  				id:'myid',style:'color:red;font-size:12pt;',size:
*  				'10':maxlength:'20',placeholder:'type name here',
*  				title:'type name to besearched here',options:
*  				['Option 1','value1'],[Option 2','value2']]},
*  				{...},{...}];
*  
*  			mysearchobj.columns.push(myColumns);
*  
*  			However previous method is preffered for clarity of code
*  
*  			Search object must be created priorr to attachement of 
*  			columns and mysearchobj.init() should be called after 
*  			grd.init() is called. 
*  			mysearchobj.grid property must be set only after 
*  			grid.init() is called
*  
*  			searchObj properties are as follows
*  
*  			mysearchobj.grid = give referance to the grid object here;
*			mysearchobj.gridVarName = 'myGrid'; //Give the var name of grid
*			mysearchobj.toolbar = give toolbar object referance here;
*			mysearchobj.toolbarVarName ='mytoolbar'; //give var name of 
*				toolBar
*			mysearchobj.workbenchVarName ='wb' ; //give the var name of 
*				workbench
*			mysearchobj.objIdB4Spacer = 'sep3';//ID of the last object before
*				the spacer. (search button is created right justified
*				on the toolbar)
*			mysearchobj.searchVarName = 'mysearchobj';//var name of the search
*				object
*			mysearchobj.toggleState = false;//Initial state of the search 
*				button by default search is inactive when grid is loaded
*			mysearchobj.filterUrl = '';//Internal property not user setable
*			mysearchobj.XMLUrl = ''; Depriciated property
*			mysearchobj.columns = [] ;//An array of searchColumnObj obhacts
*  
*  
*
*   @Author - Channa Dewamitta
*   @Date   - 12/02/2013
*   @Last Modified - 02/05/2013 , 06/07/2014,10/07/2014
*   @Last Modification - Added support for DHTMLX Auto pagination enabled
*                         grid support
*                        Added new 'Number','selection' & 'date' type fields
*                        with operator selection and calendar picker for date
*                        fields. Also fixed a problem with dettaching when
*                        multiline headers were present.
*                        Added,
*                        Added the above documentation
*   @Version - 2.0.5
*----------------------------------------------------------------------*/

var debug = true;        //set to true when debugging
var resourcesLoaded = false; // to prevent repeated loading of DHTMLX files
function searchColumnObj(){
  this.name = '';
  this.id = '';
  this.style = '';
  this.size = '5';
  this.maxlength = '';
  this.placeholder = '';
  this.title = ''; //A trext guide on hover
  this.options = []; //list of options and values for 'selection' type
  this.type = '';   //'text','bool','selection','number','date' and 'filler'
  
}

function searchObj(){ 
  this.grid = '';
  this.gridVarName = '';
  this.toolbar = '';
  this.toolbarVarName ='' ;
  this.workbenchVarName ='' ;
  this.objIdB4Spacer = '';
  this.searchVarName = '';
  this.toggleState = false;
  this.filterUrl = '';
  this.XMLUrl = '';
  this.columns = [] ;
  this.caldList = []; //Property to hold the list of date type fields to which
                     //calendar must attach By WCD on 06/07/2014
  this.searchCal = ''; //Property which holds the referance to the calender
                      // object if date type filters are present. WCD 06/07/2014
  this.searchOnEnter = false; //Property that decides how searching workes. ie. on key-by-key pressed or after enter key is pressed.
  this.propertyIsEnumerable("caldList", false);
  //methods
  this.creatHeader = function(){
      var myHeader ='';
      var count=0;
      var searchguid = this.searchOnEnter ? " Press ENTER to search!" : "";
      
      for ( var column in this.columns){ 
        var mycolumn = this.columns[column];
        var mytitle = ' title="'
                  + mycolumn.title 
                  + searchguid 
                  + '" ';
         switch (mycolumn.type) { 
             case 'text':         //Create Text type search fields
              myHeader +=  '<div class="layer1"><input type="text" size="'
                    + mycolumn.size 
                    + '" id="'+mycolumn.id
                    + '" name="'
                    + mycolumn.name
                    + '" class="searchfield" onKeyUp="self.'
                    + this.searchVarName
                    + '.reloadGrid(event)" placeholder="'
                    + mycolumn.placeholder
                    + '" style="'
                    + mycolumn.style
                    + '" '
                    + mytitle+' ></div>,';
              break;
            case 'bool':          //Create bool type search fieds (All/Yes/No)
              myHeader +=  '<div class="layer1"><select id="'
                    + mycolumn.id
                    + '" name="'
                    + mycolumn.name
                    + '" class="searchfield placeHolder" onChange="{dullColor(this);self.'
                    + this.searchVarName
                    + '.reloadGrid(event)}" placeholder="'
                    + mycolumn.placeholder
                    + '" ' 
                    + mytitle 
                    + ' ><option value="" selected="selected" class="placeHolder">All</option><option value="1">Yes</option><option value="-1">No</option></select></div>,';
              break;
            case 'selection': // Create selection type filters
      				// TO BE DONE
      				if( mycolumn.options == undefined) { //If options are not defined
      					myHeader += '<div class="layer1"><select id="'
      						+ mycolumn.id
      						+ '" name="'
      						+ mycolumn.name
      						+ '" class="searchfield placeHolder" onChange="{dullColor(this);'
      						+ this.searchVarName
      						+ '.reloadGrid(null)}" placeholder="'
      						+ mycolumn.placeholder
      						+ '"><option value="" selected="selected" class="placeHolder">All</option></select></div>,';
      				}else {
      					myHeader += '<div class="layer1"><select id="'
      						+ mycolumn.id
      						+ '" name="'
      						+ mycolumn.name
      						+ '" class="searchfield placeHolder" onChange="{dullColor(this);'
      						+ this.searchVarName
      						+ '.reloadGrid(null)}" placeholder="'
      						+ mycolumn.placeholder
      						+ '"><option value="" selected="selected" class="placeHolder">All</option>';
      					for (var option in mycolumn.options){
      						myHeader += '<option value="' + mycolumn.options[option][1] + '">'
      								+ mycolumn.options[option][0] 
      								+ '</option>' ;
      					}
      					myHeader +=  '</select></div>,';
      				}
      				break;
      			case 'number': // Create Number/Value type search filters
      				myHeader += '<div class="layer1"><input type="text" size="'
      						+ mycolumn.size + '" id="' + mycolumn.id
      						+ '[0]" name="' + mycolumn.name
      						+ '[]" class="searchfield_number" onKeyUp="{numValidate(this);'
      						+ this.searchVarName + '.reloadGrid(event);}" placeholder="'
      						+ mycolumn.placeholder + '" style="' + mycolumn.style
      						+ '" ' + mytitle.substr(0,mytitle.length-2) 
                  + ' Place any one of the logical operators '
      						+ "'=&#044;&lt;&#044;&gt;&#044;&lt;=&#044;&gt;=' in the first position OR use '..' "
      						+ " for range selection like '200..400' for values between 200 &amp; 400\" >";
      				myHeader += '<input type="text" size="'
      						+ mycolumn.size
      						+ '" id="'
      						+ mycolumn.id
      						+ '[1]" name="'
      						+ mycolumn.name
      						+ '[]" class="searchfield number" style="display:none;">';
      				myHeader += '<input type="text" size="'
      						+ mycolumn.size
      						+ '" id="'
      						+ mycolumn.id
      						+ '[2]" name="'
      						+ mycolumn.name
      						+ '[]" class="searchfield_number" style="display:none;">';
      				myHeader += '<input type="text" size="'
      						+ mycolumn.size
      						+ '" id="'
      						+ mycolumn.id
      						+ '[3]" name="'
      						+ mycolumn.name
      						+ '[]" class="searchfield_number" style="display:none;"></div>,';
      				break;
      			case 'date': // Create date with calendar type search filters
      				function resLoaded(resName,resType){
      					var myresources = resType == 'stylesheet'? document.styleSheets :document.scripts;
      					if (myresources != undefined){
      						for (var myres in myresources){
      							if (resType == 'stylesheet' && myresources[myres].href != undefined){
      								myresName = myresources[myres].href.split('/');
      							}else if(myresources[myres].src!= undefined){
      								myresources[myres].src.split('/'); 
      							}
      							myresName = myresName[myresName.length-1];
      							if (myresName == resName) return true;
      						}
      					}
      					return false;
      				}
      				function addResource(href,resType){
      					if (resType=='stylesheet'){
      						var newRes = document.createElement('link');
      						newRes.rel = 'stylesheet';
      						newRes.type = 'text/css';			
      						newRes.href = href;
      					}else {
      						var newRes = document.createElement('script');
      						newRes.type = 'text/javascript';			
      						newRes.src = href;
      					}
      					document.head.appendChild(newRes);
      				}
      				if (!resourcesLoaded){
      					if (!resLoaded('dhtmlxcalendar.css','stylesheet')) addResource('../dhtmlx/dhtmlxCalendar/codebase/dhtmlxcalendar.css','stylesheet');
      					if (!resLoaded('dhtmlxcalendar_dhx_skyblue.css','stylesheet')) addResource('../dhtmlx/dhtmlxCalendar/codebase/skins/dhtmlxcalendar_dhx_skyblue.css','stylesheet');
      					if (!resLoaded('dhtmlxcalendar.js','script')) addResource('../dhtmlx/dhtmlxCalendar/codebase/dhtmlxcalendar.js','script');
      					resourcesLoaded = true;
      				}
      				myHeader += '<div class="layer1"><select id="'
      						+ mycolumn.id
      						+ '[0]'
      						+ '" name="'
      						+ mycolumn.name
      						+ '[]'
      						+ '" class="searchfield placeHolder date" onChange="{dullColor(this);'
      						+ this.searchVarName + '.dateValidate(this);'
      						+ this.searchVarName
      						+ '.reloadGrid(null)}" placeholder="'
      						+ mycolumn.placeholder
      						//+ '" style="width: 40px; font-size: 6pt;"'
      						+ '" title="Select any one of the logical operators '
      						+ "'=&#044;&lt;&#044;&gt;&#044;&lt;=&#044;&gt;=' OR '..' for range from here &amp; select the date(s) as appropriate from adjacent field(s)."
      						+ '"><option value="" selected="selected" class="placeHolder">All</option><option value="=">=</option><option value="<">&lt;</option><option value=">">&gt;</option><option value="<=">&lt;=</option><option value=">=">&gt;=</option><option value="..">..</option></select>';
      			
      				myHeader += '<input type="text" size="'
      						+ mycolumn.size
      						+ '" style="font-size:6pt;display:none;" onChange="{'
      						+ this.searchVarName + '.dateValidate(this);'
      						+ this.searchVarName
      						+ '.reloadGrid(null)}"'
                  + ' readonly="readonly"'
      						+ ' id="'
      						+ mycolumn.id
      						+ '[1]" name="'
      						+ mycolumn.name
      						+ '[]" class="searchfield_date" >';
      				myHeader += '<input type="text" size="'
      						+ mycolumn.size
      						+ '" style="font-size:6pt;display:none;" onChange="{'
      						+ this.searchVarName + '.dateValidate(this);'
      						+ this.searchVarName
      						+ '.reloadGrid(null)}"'
                  + ' readonly="readonly"'
      						+ ' id="'
      						+ mycolumn.id
      						+ '[2]" name="'
      						+ mycolumn.name
      						+ '[]" class="searchfield_date" >'
      						+ '</div>,';
      				this.caldList.push(mycolumn.id + '[1]');
      				this.caldList.push(mycolumn.id + '[2]');
      				break;
            case 'filler':       //Create Fillers (#rspans)
              myHeader += '#rspan,';
              break;
         }
         count=count+1;
      }
      myHeader = myHeader.substring(0,(myHeader.length-1)); //Remove trailing ','
      if (debug) console.log('myHeader is :-',myHeader);
      return myHeader;
  };
  
  this.toggleSearch = function (){
    this.toggleState = !this.toggleState;
    if (this.toggleState) {
      this.toolbar.setItemImage('search','find_dis.png'); //Set difused image
      var tempHeader =  this.creatHeader();
      this.grid.attachHeader(tempHeader);
      //Following line is not required as the refreash problem is fixed on
      // workbench now
      //this.toolbar.setItemImage('refresh','reset_dis.png');
      //--------------------------------
      //If any 'date' type filters exists add calendars to them
      if (this.caldList.length >0){
    	  this.searchCal = new dhtmlxCalendarObject(this.caldList);
    	  var activeInput = '';
    	  this.searchCal.attachEvent('onBeforeChange', function(){
    		  activeInput = this._activeInp ;
    	  	  return true;
    	  });
    	  this.searchCal.attachEvent('onClick', function(){
        	  this.i[activeInput].onchange();
        	  return true;
          });
      }
      //---------------------------------
    } else { 
      if (this.grid._aHead == undefined) { //No attached multiline headers
        this.grid.detachHeader(1);
      }else {  //remove search header from multiline header 
        this.grid.detachHeader(this.grid._aHead[0].indexOf("_aHead"));   
      }
      if (this.XMLUrl.length ==0) this.XMLUrl = this.grid.xmlFileurl ;
      
      this.toolbar.setItemImage('search','find.png');   //set to active image
      this.toolbar.setItemImage('refresh','reset.png');
      this.filterUrl = ''; //alert('File URL is :-'+ this.grid.xmlFileUrl)  ;
      //-----------------------------------------
      var myUrl = this.grid.xmlFileUrl == '' ? this.XMLUrl : this.grid.xmlFileUrl;
      //If DHTMLX Auto pagination is active w need to remove the querry string
      //that is embedded in the xmlFileUrl. WCD 02/05/13
      var queryStart = myUrl.indexOf('?');
      myUrl = queryStart < 0 ? myUrl : myUrl.substr(0,queryStart);
      //---End pagination support----
      myUrl = myUrl.replace('/true/','/false/','gi');
      this.grid.clearAndLoad(myUrl); 
      //-----------------------------------------
      //this.grid.clearAndLoad(this.grid.xmlFileUrl);
      //this.grid.clearAndLoad(this.XMLUrl);
    }
    this.grid.render_dataset();       //Show the added/removed Header
  };

  this.init = function () {
    //We need to do more here. Have to find out the current status and then
    //add the button to the left corner . This was don in the following way WCD
    if (debug) console.log('Sarch object is :-'+ this);
     //this.toolbar.addSpacer('spcSearch');
    if (this.toolbar._spacer === undefined) {
     if (this.objIdB4Spacer === '') {
      this.objIdB4Spacer = 'sepSearch98' ;
      this.toolbar.addSeparator(this.objIdB4Spacer,98);
     }
     this.toolbar.addSpacer(this.objIdB4Spacer);
     //this.toolbar.removeItem('sepSearch98')
    }
    
    if (this.toolbar._spacer === undefined) this.toolbar.addSpacer('spcSearch');
    this.toolbar.addSeparator('sepSearch',99);
    this.toolbar.addButton('search',100,'Search','find.png','find_dis.png'); 
    this.toolbar.setItemToolTip('search','Activate/Deactivate data search');
  };
  
  this.addColumn = function (mycolumn){
    if (!mycolumn) {
      mycolumn = new searchColumnObj();
      mycolumn.name = 'col' + (this.columns.length + 1);
    }
    this.columns[mycolumn.name]= mycolumn;
  };

}

searchObj.prototype = {
  reloadGrid: function (event){ 
    if (this.searchOnEnter && event != undefined && event.keyCode != 13) return ;
      //alert(vent.keyCode);
      //build filter url
      this.filterUrl = '';  
      var inputs = document.getElementsByClassName('searchfield') ;
  
      for (var myinput=0; myinput< inputs.length ; myinput++) {
        if (debug) console.log('input :-'+inputs[myinput].name);
        if (inputs[myinput].value !='' && inputs[myinput].value != null ) {
           //this.filterUrl += inputs[myinput].name + '=' + inputs[myinput].value + '&'; 
           //We need to do some more work here
           //if input is not an array (name has no '[]')
           if (inputs[myinput].name.substr(-2)!='[]'){
            this.filterUrl += inputs[myinput].name + '_like' + '=' + inputs[myinput].value + '&';
           }else {
            var fieldset = document.getElementsByName(inputs[myinput].name);
            var start = fieldset.length == 4 ? 1 : 0;//To avoid the display field of 'number' type
            var myfieldName = fieldset[start].name.substr(0,fieldset[0].name.length-2) ;
            switch (fieldset[start].value) {
              case '=':
                this.filterUrl += myfieldName
                          + '_equal'
                          + '='
                          + fieldset[start+1].value
                          + '&';
                break;
              case '<':
                this.filterUrl += myfieldName
                          + '_lt'
                          + '='
                          + fieldset[start+1].value
                          + '&';
                break;
              case '>':
                this.filterUrl += myfieldName
                          + '_gt'
                          + '='
                          + fieldset[start+1].value
                          + '&';
                break;
              case '>=':
                this.filterUrl += myfieldName
                          + '_gtequal'
                          + '='
                          + fieldset[start+1].value
                          + '&';
                break;
              case '<=':
                this.filterUrl += myfieldName
                          + '_lteqals'
                          + '='
                          + fieldset[start+1].value
                          + '&';
                break;
              case '..':
                this.filterUrl += myfieldName
                          + '_gtequal'
                          + '='
                          + fieldset[start+1].value
                          + '&';
                this.filterUrl += myfieldName
                          + '_ltequal'
                          + '='
                          + fieldset[start+2].value
                          + '&';
                break;
            }
           } 
        }
      }
      this.filterUrl = this.filterUrl.substring(0,(this.filterUrl.length-1));  //remove extra '&'
      this.filterUrl += this.filterUrl.length > 0? '&filtersOn=true':'filtersOn=true';       //For stopping xml column heades
     
      //var myUrl = this.grid.xmlFileUrl == '' ? this.XMLUrl : this.grid.xmlFileUrl;
      var myUrl = this.grid.xmlLoader.filePath; //WCD 07/05/2013
      
      if (debug) console.log('myUrl is ;-'+myUrl);
      //If DHTMLX Auto pagination is active w need to remove the querry string
      //that is embedded in the xmlFileUrl. WCD 02/05/13
      var queryStart = myUrl.indexOf('?');
      myUrl = queryStart < 0 ? myUrl : myUrl.substr(0,queryStart);
      //---End pagination support----
      myUrl = myUrl.replace('/false/','/true/','gi'); 
      if (debug) console.log('xmlUrl is :- ',myUrl + '?'+this.filterUrl);
      this.grid.clearAndLoad(myUrl + '?'+this.filterUrl);
      //this.grid.clearAndLoad(this.grid.xmlFileUrl  + '?'+this.filterUrl);
      //this.grid.clearAndLoad(this.XMLUrl + '?'+this.filterUrl);
    },
dateValidate: function(me){
	//function dateValidate(me){
		//Check the operator selected first
		if (me.type == 'select-one'){
			if(me.value == '') {
				document.getElementById(me.id.replace('0','2')).style.display="none";
				document.getElementById(me.id.replace('0','1')).style.display="none";
				document.getElementById(me.id.replace('0','1')).value='';
				document.getElementById(me.id.replace('0','2')).value='';
				this.grid.render_dataset(); 
				return false;
			}
			if(me.value == '..'){
				document.getElementById(me.id.replace('0','1')).style.display="";
				document.getElementById(me.id.replace('0','2')).style.display="";
				this.grid.render_dataset(); 
			}else {
				document.getElementById(me.id.replace('0','1')).style.display="";
				document.getElementById(me.id.replace('0','2')).style.display="none";
				document.getElementById(me.id.replace('0','2')).value='';
				this.grid.render_dataset(); 
			}
		}else {
			if (me.value =='') return false ;
			//TODO Should we validate the Dates here?
		}
	}
  
};

//this function handles a display effects of the dropdown when default item is
//selected  (Grayed)
function dullColor(me){
  if (me.value) {
    me.style.color='#000000';
  }else {
    me.style.color='#6D6D6D';
  }
}

function numValidate(me){
		//validate the input for number keys and any '.,=,<,>,<=,>=,..'
		var reg = /(?:^(=|<|>|<=|>=)\s*(?:(\d+?$)|(\d+?\.\d{1,2}?$)))|(?:(^\d+(?=\.\.))|(^\d+\.\d{1,2}(?=\.\.)))((?!\d)\.{2}(?=\d))(?:((?!\.\.)\d+$)|((?!\.\.)\d+\.\d{1,2}$))/;
		var items =reg.exec(me.value);
		/*
		if(items == null){
			//alert("invalid input! only '=|<|>|<=|>=|' and integer or decimal value OR integer or decimal'..'integer or decimal (range filter) allowed.");
			return;
		}*/
		var myInputs = document.getElementsByName(me.name);
		for (var i = 1; i<myInputs.length; i++){
			myInputs[i].value= null;
		}
		if(items != null) items.index++; //skip item 0
		while (items != null && items.index <= items.lastIndexOf()) {
			
		    if (items[items.index] != undefined) {
		    	switch (items[items.index]){
		    	case "=":
		    		myInputs[1].value="=";
		    		break;
		    	case "<":
		    		myInputs[1].value="<";
		    		break;
		    	case ">":
		    		myInputs[1].value = ">";
		    		break;
		    	case ">=":
		    		myInputs[1].value = ">=";
		    		break;
		    	case "<=":
		    		myInputs[1].value = "<=";
		    		break;
		    	case "..":
		    		myInputs[1].value = "..";
		    		break;
		    	default:
		    		if (myInputs[2].value == "") myInputs[2].value=items[items.index];
		    		else myInputs[3].value = items[items.index];
		    	}
		    }
		    // View your result using the m-variable.
		    //alert(items[items.index]);
		    items.index++;
		    
		}
		if (myInputs[2].value == "") return false;
		if (debug && items != null) console.log('search text is :-',items.toString());
		return true;
}
