<?php
if ( ! function_exists('getHeadersList'))
{
         function getHeadersList($one_record)
         {
		/**
		 * getHeadersList() function
		 *
		 * Parses data array and return list of headers
		 *
		 * @param $one_record one record from data array
		 *
		 * @return comma separated list of headers
		 */
			$out = array();
			$one_record=array_slice($one_record,1);
			foreach($one_record as $h)
			{
				$out[] = $h['header'];
			}
			
			 return join(',',$out);
         }
}
if ( ! function_exists('convertHTMLTable'))
{
			/**
		 * convertHTMLTable() function
		 *
		 * Prepares and echoes HTML table for jQuery datatables
		 *
		 * @param $data Data Array
		 *
		 * @return void
		 */
     function convertHTMLTable($data,$widths='',$colList = false)
     {
        $widthArr = array();
        $dashBoardURL = array();
        if(is_array($widths)) $widthArr = $widths ;
        ////////////////////////////////////////////////////
    	  $dataset = $data['dataset']['result_set'];
        
        
    	 $pk = explode(",",$data['dataset']['metadata']['PK']);
        //------------ Create headers -------------------
        //$headerList = getHeadersList($dataset['dataset']['metadata']);
        //$headers = explode(',',$headerList);
        $headers =array_slice($data['dataset']['metadata'],1);
        $tableHTML = "\n<table id='datatable' style='' class=''>\n\t~HEADERS~\n\t\n\t<tbody>~DATAROWS~\n\n\t</tobody>\n\t<tfoot>~HEADERS~\n\t</tfoot>\n</table>";
        $headerHTML = '';
        $headerHTML .= "\n\t<colgroup>";
        foreach($headers as $key=>$h)     //Set col widths
  			{
          if($h['width'] =="" || $h['width'] < "15"){
          	$width="50";              
          }else{
          	$width=$h['width'];              	
          }
          
          if ($colList) {            
            if (in_array($key,$colList) ) { 
              if (sizeof($widthArr)>0) { //User specified column widths are active
                $width=$widthArr[$key];
              }
              $headerHTML .= "\n\t\t\t<col style='width:{$width}em;' >";
            }
          }else{
            $headerHTML .= "\n\t\t\t<col style='width:{$width}em;'>";
          }
  			}
        $headerHTML .= "\n\t</colgroup>\n\t<thead>";
        $headerHTML .= "\n\t\t<tr>";
  			foreach($headers as $key=>$h)
  			{
          if ($colList) {
            if (in_array($key,$colList) ) {
              //$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='width:{$h['width']}; text-align: center;'>{$h['header']}</th>";
              $headerHTML .= "\n\t\t\t<th class=\"headercell\" style='text-align: center;'>{$h['header']}</th>";
            }
          }else{
            //$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='width:{$h['width']}; text-align: center;'>{$h['header']}</th>";
            $headerHTML .= "\n\t\t\t<th class=\"headercell\" style='text-align: center;'>{$h['header']}</th>";
          }
  			}
        $headerHTML .= "\n\t\t</tr>\n\t</thead>";
        // ----------end of headers -----------------
  			$nrows = sizeof($dataset) ;
        $datarowHTML = '';
        for($i=1;$i<=$nrows;$i++)
        {
          $datarowHTML .= "\n\t\t<tr>\n";
          foreach($dataset[$i] as $key=>$v)
          {   
            if(!(isset($v))) {
              $thisValue = '';
            } else {
              $thisValue = $v;
            }
            if ($colList){
              if(in_array($key,$colList) ){
                $datarowHTML .= "\n\t\t\t<td class=\"datarow\">".stripslashes($thisValue)."</td>";
              }
            }else {
              $datarowHTML .= "\n\t\t\t<td class=\"datarow\">".stripslashes($thisValue)."</td>\n";
            }
  				}
          $datarowHTML .= "\n\t\t</tr>\n";
  			 }
  			 $out = str_replace('~HEADERS~',$headerHTML,(str_replace('~DATAROWS~',$datarowHTML,$tableHTML)));
  			 return $out;
      }
}

if ( ! function_exists('getArrayElements'))
{
	/**
	 * getArrayElements() function
	 *
	 * Returns wanter array element, if exists
	 *
	 * @param $array , the array
	 *
	 * @param $key , key to be checked
	 *
	 * @return String, array element value if found, otherwise an empty string
	 */
	function getArrayElements($array,$key)
	{
		if(is_array($array))
		{
			if(array_key_exists($key,$array))
			{
				return $array[$key];
			}
			else
				return '';
		}
		else
			return '';
	}
}

/**
 * input() function
 *
 * Prepares and echoes HTML Code for Input feilds
 *
 * @param $data Data Array
 *
 * @param $pkval , Value of the primary key field of data record, to identity record
 *
 * @param $field, Name of database table field
 *
 * @param $type Optional, type of input tag, Default Text
 *
 * @return void
 */
function input($data,$pkval,$field,$type="text")
{

	$dataset = $data['dataset']['result_set'];
    $pk = explode(",",$data['dataset']['metadata']['PK']);
	
	$nrows = sizeof($dataset) - 1;
	for($ix=1;$ix<=$nrows;$ix++)
	{
		if($ix > 0)
		{
			unset($pk_g);
			foreach($pk as $col){
				$pk_g[] = $dataset[$i][$col];
				 
			}
			$pk_grid=join("_",$pk_g);
			unset($pk_g);
			if($pk_grid == $pkval)
			{
				echo '<input type="'.$type.'" id="'.$field.$pkval.'" name="'.$field.$pkval.'" value="'.$dataset[$ix][$field] .'">';
			}
		}
		$pk_grid="";
		$ix++;
	}
}




////////////////////////////////////////////////////////////////////////////////////////////
// old drop down function for dinishika's refference . Pls delete this section after reffering them.

/*
 * 
 * 
function dropdown($data,$selectByText=null,$selectByVal,$label, $fieldName, $display,$format='html',$keyfield=true,$multiple=false,$skipfield=false,$optionsOnly=false)
{
	
	$dataset = $data['dataset']['result_set'];
	$pk = $data['dataset']['metadata']['PK'];

  if ($selectByText && $selectByVal) $selectByText = null; // Choos ByVal if both provided //WCD
	//if its calling for multiple select box with or without default selected ids
	// IF $selected is a sring of comaseperated values we do not need all below code
  
   
	
    switch ($format) {
        
    case 'html':
	  
    	   	
	    if (!is_array($pk)) $pk = explode(',', $pk);
    	$nrows = sizeof($dataset) - 1;
        $mul = ($multiple)?'[]':'';
	    if(!$optionsOnly) {     
        echo '<select size="1"  id="'.$fieldName.'" name="'.$fieldName.$mul.'" label="'.$label.'" ';
      
	    if($multiple) echo ' MULTIPLE ';
        echo '>',"\n";          
      }
        if(empty($selectByText) && empty($selectByVal)){
        	echo "\t",'<option value="" selected="selected" >Select.... </option>',"\n";
	    }else{
			echo "\t",'<option value="" >Select.... </option>',"\n";
		}

 		
          
           for($ix=1;$ix<=$nrows;$ix++) {
              if($ix > 0) {
              	$val='';
                //for composite keys construct the composit value with '_'
                //suffix
                foreach($pk as $key){
                  $val .= $dataset[$ix][$key].'_';
                }
                $val=trim($val,'_');
                $selectedAttrib = null;
                $foundText= false; $foundVal=false;
    		
		
		  if(!empty($selectByText) || !empty($selectByVal) ){
                 
 			//Error suppression used to suppres the empty string error. WCD
			if(!empty($selectByText) && !empty($dataset[$ix][$fieldName])){
                     	$foundText = strpos($selectByText,(string)$dataset[$ix][$fieldName]);
			}else{ $foundText = false;}
			
			if(!empty($selectByVal) && !empty($val)){
				$foundVal = strpos($selectByVal,$val) ;
			}else{ $foundVal = false;}
			
			// for some reason following code returns 1 or 0 insted of booleon true of false.therefor commented
			//$foundText = (strcasecmp((string)$selectByText, (string)$dataset[$ix][$fieldName]) == 0)? true: false ;
			//$foundVal = (strcasecmp((string)$selectByVal,(string) $val) == 0)?  true : false ;
                }
			
		
			
				
		if($foundText !== false || $foundVal !== false ) {
			$selectedAttrib = 'selected="selected"';									
		}

		echo "\t",'<option value="'.$val.'" '.$selectedAttrib.' >'.formatString($dataset[$ix][$display]).'</option>',"\n";
              }//end if(ix)   
            }//end for     
            
            echo '</select>',"\n";
                      			
		break;
				
        case 'xml':
        	
        	if (!is_array($pk)) $pk = explode(',', $pk);
        	
        	$nrows = sizeof($dataset);
        	
        	if($multiple) { $type='multiselect'; } else { $type='select';}
        	 
        	$name=$fieldName;
        	
        	if($skipfield==true) {
        		$name=$fieldName.'_skip';
        	}
        	
                if(!$optionsOnly) {
        	echo '<item type="'.$type.'" name="'.$name.'" id="'.$name.'" label="'.$label.'">';        	
        	}

        	if(empty($selectByVal)&& empty($selectByText)){
        		echo "\n\t",'<option value=""  selected="true"  label="Select...."  >Select....</option>';
        	}else{
        		echo "\n\t",'<option value="" label="Select...."  >Select....</option>';
        	}
        	
        	
        	for($ix=1;$ix<=$nrows;$ix++){
        		
          	if($ix > 0)
          		{
          			$val='';
          			foreach($pk as $key){
          				$val .= $dataset[$ix][$key].'_';
          			}
          	
          			$val=trim($val,'_');        
                  $foundText= false; $foundVal=false;				
                  if(!empty($selectByVal)|| !empty($selectByText)){
                    //Error suppression used to suppres the empty string error. WCD
                    $foundText = @strpos($selectByText,(string)$dataset[$ix][$fieldName]);			
			//(strcasecmp($selectByText, (string)$dataset[$ix][$fieldName]) == 0)? $foundText = true :$foundText = false ;
			$foundVal = strpos($selectByVal,$val) ;
			//(strcasecmp($selectByVal, $val) == 0)? $foundVal = true :$foundVal = false ;

                  }
        	        if($foundText !== false || $foundVal !== false ) {
         						$selectedAttrib = 'selected="true"';
        					}else{
        						$selectedAttrib = '';
        					}        				
          				echo "\n\t",'<option value="'.$val.'" '.$selectedAttrib.' label="'.formatString($dataset[$ix][$display]).'" >'.formatString($dataset[$ix][$display]).'</option>';
          	 
          	}//end if(ix)
        		
        	}//end for
        	
               if(!$optionsOnly) {
        	echo "\n\t",'</item>';
               }	
         
         break;      

         
        case 'list':
            //to do
            break;
        
        case 'json':
            //todo
            break;          
            
   }//end switch case
   
}//end of dropdown();

 * 
 * */

///////////////////////////////////////////////////////////////////////////////////////////


/**
 * dropdown() function
 *
 * Prepares and echoes HTML/DHTMLX Code for Dropdown list
 *
 * @param $data - required - Data Array
 * 
 * @param $name - required - The name and the id of the dropdown controller.
 * 
 * @param $fieldName - required - The field name of the record set which is to be listed in options.
 *
 * @param $selectByText - optional - The option text(s) to be selected on load of the dropdown.  
 *
 * @param $selectByVal - optional -The option value(s) to be selected on load of the dropdown 
 *
 * @param $format - optional - The dropdown output format as html or xml
 * 
 * @param $multiple - optional - to specify either multiple select or single select option
 * 
 * @param $optionsOnly - optional - To specify to output only options list without select controller
 * 
 * @return void
 * 
 * Updates:
 * 
 * 1. Rearranged parameter list from required to optional  from left to right 
 * 2. Removed unwanted parameters - $keyfield,$skipfield,$label
 * 			
 * Updated on 11/4/2013
 * 
 * By: MRoshan
 * 
 * 
 *   $dataArray = array('data' => $data,
 *   					'fieldName' => $fieldName,  (html name attrib)
 *   					'label' => $label,
 *   					'selectByText' => null,
 *   					'selectByVal' => null,
 *   					'format' => 'html',
 *   					'multiple' => false,
 *   					'optionsOnly' => false
 *    );
 * 
 * //function dropdown($data, $name, $fieldName,$label, $selectByText=null, $selectByVal=null, $format='html', $multiple=false, $optionsOnly=false)

 * */


function dropdown($dataArray)
{
	
	/* 
	 * following set of codes are common for both xml and html code segments. 
	 * 
	 * */
	
    	$dataset = $dataArray['data']['dataset']['result_set'];
    	$pk = $dataArray['data']['dataset']['metadata']['PK'];
	   $fieldName = isset($dataArray['fieldName'])? $dataArray['fieldName']: null;
	   $selectByText = isset($dataArray['selectByText'])? $dataArray['selectByText']:null;
	   $selectByVal = isset($dataArray['selectByVal'])? $dataArray['selectByVal']:null;
	   $format = isset($dataArray['format'])? $dataArray['format']:null;
	  $multiple = isset($dataArray['multiple'])? $dataArray['multiple']:false;
	  $optionsOnly = isset($dataArray['optionsOnly'])? $dataArray['optionsOnly']:false;
	  $label = isset($dataArray['label'])? $dataArray['label']:null;
         $display = isset($dataArray['display'])? $dataArray['display']:null;
        $required = isset($dataArray['required'])? $dataArray['required']:null;
         
    if ($selectByText && $selectByVal) $selectByText = null; // Choos ByVal if both provided //WCD
 
	
    switch ($format) {
        
    case 'html':
	  
    	   	
	    if (!is_array($pk)) $pk = explode(',', $pk);
    	$nrows = sizeof($dataset) ;
        $mul = ($multiple)?'[]':'';
        
	    if(!$optionsOnly) {     
        	echo '<select size="1"  id="'.$fieldName.'" name="'.$fieldName.$mul.'" label="'.$label.'" ';      
	    	if($multiple) echo ' MULTIPLE ';
        	echo '>',"\n";          
      	}//end if(options)
      		
        if(empty($selectByText) && empty($selectByVal)){
        	echo "\t",'<option value="" selected="selected" >Select.... </option>',"\n";
	    }else{
			echo "\t",'<option value="" >Select.... </option>',"\n";
		}		

		$sbt = null;
        for($ix=1;$ix<=$nrows;$ix++) {
        	
        	if($ix > 0) {

        		$val='';
                //for composite keys construct the composit value with '_'
                //suffix
                
                foreach($pk as $key){
                  $val .= $dataset[$ix][$key].'_';
                }
                
                $val=trim($val,'_');
                $selectedAttrib = null;
                $foundText= false; $foundVal=false;
    		
		
		  		if(!empty($selectByText) || !empty($selectByVal) ){
		  			
		  			if(!empty($selectByText) && !empty($dataset[$ix][$display])){
		  				
                     	//$foundText = strpos($selectByText,(string)$dataset[$ix][$display]);
                     	$sbt = explode(',',$selectByText);
                     	$foundText = in_array($dataset[$ix][$display],$sbt);
                     	
					}else{ 
						$foundText = false;
					}
			
					if(!empty($selectByVal) && !empty($val)){
						$foundVal = strpos($selectByVal,$val) ;
					}else{ 
						$foundVal = false;
					}			
		
           }//end if(!empty($selectByText)
           
           if($foundText !== false || $foundVal !== false ) {
           	
		   		$selectedAttrib = 'selected="selected"';									
		   }
		   echo "\t",'<option value="'.$val.'" '.$selectedAttrib.' >'.formatString($dataset[$ix][$display]).'</option>',"\n";
			
      	}//end if(ix)
      		   
      }//end for     

      if(!$optionsOnly) {
      		echo '</select>',"\n";
      }
                      			
	break;
				
    case 'xml':
        	
        	
        	if (!is_array($pk)) $pk = explode(',', $pk);
        	
        	$nrows = sizeof($dataset);
        	
        	if($multiple) { $type='multiselect'; } else { $type='select';}
                if($required) { $validate='NotEmpty'; } 
        	 
        	               	
            if(!$optionsOnly) {
                        if($required) {
                        echo '<item type="'.$type.'" name="'.$fieldName.'" id="'.$fieldName.'" label="'.$label.'" validate="NotEmpty" required="true">';  
                        }else {    
        		echo '<item type="'.$type.'" name="'.$fieldName.'" id="'.$fieldName.'" label="'.$label.'">';     
                        }   	
        	}

        	if(empty($selectByVal)&& empty($selectByText)){
        		echo "\n\t",'<option value=""  selected="true"  label="Select...."  >Select....</option>';
        	}else{
        		echo "\n\t",'<option value="" label="Select...."  >Select....</option>';
        	}
        	
        	$sbt = null;
        	for($ix=1;$ix<=$nrows;$ix++){ 
        		
          	if($ix > 0)
          		{
          			$val='';
          			foreach($pk as $key){
          				$val .= $dataset[$ix][$key].'_';
          			}
          	
          			$val=trim($val,'_');        
          			
                  	$foundText= false; $foundVal=false;				
                  
                  	if(!empty($selectByVal)|| !empty($selectByText)){

                  		if(!empty($selectByText) && !empty($dataset[$ix][$display])){
                  		
                  			//$foundText = strpos($selectByText,(string)$dataset[$ix][$display]);
                  			$sbt = explode(',',$selectByText);
                     		$foundText = in_array($dataset[$ix][$display],$sbt);
                  		}else{
                  			$foundText = false;
                  		}
                  			
                  		if(!empty($selectByVal) && !empty($val)){
                  			$foundVal = strpos($selectByVal,$val) ;
                  		}else{
                  			$foundVal = false;
                  		}	
             
                  }//endif
                  
        	      if($foundText !== false || $foundVal !== false ) {
         		  		$selectedAttrib = 'selected="true"';
        		  }else{
        				$selectedAttrib = '';
        		  }        				
          		
        		  echo "\n\t",'<option value="'.$val.'" '.$selectedAttrib.' label="'.formatString($dataset[$ix][$display]).'" >'.formatString($dataset[$ix][$display]).'</option>';
          	 
          		}//end if(ix)
        		
        	}//end for
        	
            if(!$optionsOnly) {
        		echo "\n\t",'</item>';
            }
           	
         break;            
        case 'list':
            //to do
            break;
        
        case 'json':
            //todo
            break;          
            
   }//end switch case
   
}//end of dropdown();





/*###################################### Added by Dinishika ####################*/
function formatString($string) {
            
           $string = str_replace ( '&', '&amp;', $string );

           return $string;
}
/*###########################################################################*/


if ( ! function_exists('converDHTMLXGrid')) {
  /**
  * converDHTMLXGrid() function
  *
  * Prepares and echoes XML for DHTMLX Data Grid
  *
  * @param $data Data Array
  *
  * @param $sr Optional, Enable/Disable Smart Rendering, Boolean TRUE/FALSE,
  *  Default false
  *
  * @param $start Optional, Start Position of data included in XML, Default 0
  *
  * @param $nnrows Optional, Number of data rows to included in XML, Default 20
  *
  * @param $includeHeaders   boolean, optional, use true to have headers included
  *  in XML, otherwise keep it false
  *
  * @param $widths , array of column widths, optional (e.g. array('col1'=>100,'col2'=>150,'col3'=>200); ) 
  *
  * @param $cellStyles , array of CSS styles, optiona (e.g. array('color:red;font-
  * weight:bold;','color:#00ff00'); )
  *
  * @param $colList , array of columns to  display, optional (e.g. array('col1','col2','col3'); ) table column names  
  * @return String, Grid XML
  */
  function converDHTMLXGrid($data,$sr = false, $start=0,$nnrows=20,$includeHeaders=false,$widths='',$cellStyles='',$colList = false) {
    
    $widthStr = '';
    $widthArr = array();
    $rowStyleStr = '';
    $rowStylesArr = array();
    $sidx = 0;
    
  	// For debuging WCD
    log_message('debug',"DATA ARRAY :- ".serialize($data));	 
    if(is_array($widths))
    {	
      /*foreach($widths as $w)
      {
      	$widthArr[] = $w;
      }	*/
      $widthArr = $widths ;		 
    }
    if(is_array($cellStyles))
    {	
    foreach($cellStyles as $rsty)
      {
      	$rowStylesArr[] = $rsty;
      }			 
    }
    $dataset = $data['dataset']['result_set'];
    $pk = explode(",",$data['dataset']['metadata']['PK']);
    //$headerList = getHeadersList($data['dataset']['metadata']);
    //$headers = explode(',',$headerList);
    $headers =array_slice($data['dataset']['metadata'],1);
    $nrows = sizeof($dataset);
    $nnrows = ($nrows < $nnrows)?$nrows:$nnrows;     
         
    //set header for XML Using DOM to do a clean job
    $doc = new DOMDocument('1.0', 'UTF-8');
    /*
    $doc->formatOutput = true;     //To produce output in a nice way
    
    header("Access-Control-Allow-Headers: X-Requested-With");
    if (stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
        header("Content-type: application/xhtml+xml"); 
    } else {
        header("Content-type: text/xml");
    }  */
    //Set Row data for XML
    $myrows = $doc->createElement("rows");
    //Following for smart rendering. Does not work with paging--
    if ($sr)   {
      $myrows->setAttribute('pos', $start);
      $myrows->setAttribute('rec_count', $nrows);
    }
    //Smart rendering End ---------------------------------------
    
    $doc->appendChild($myrows);
    //Following needed for paging ------------------
    // Put Paging code here (Not needed for DHTMLX Enterprice version)
    //Paging End -----------------------------------
    
    //-----For column Headers---------
    $listCols = is_array($colList) ?  $colList :  $headers;
    if($includeHeaders)
    {  
        $myhead = $doc->createElement("head");
        $myrows->appendChild($myhead);
        $hix = 0;
  		foreach($headers as $key=>$h)
  		{
        if ($colList) {
          if (in_array($key,$colList)){
            $mycolumn = $doc->createElement("column");
            $mycolumn->setAttribute('type', 'ro');
            $mycolumn->setAttribute('align', 'center');
            $mycolumn->setAttribute('sort', 'str');
            //$mycolumn->setAttribute('width', getArrayElements($widthArr,$hix));
            //TODO The following code should be modified to get the header width
            // as the minimum width if a width is not specified by user. WCD
            if (sizeof($widthArr)>0) { //User specified column widths are active
              $width=$widthArr[$key];
            }else{ //User not specified column widths so use header stuff
              if($h['width'] =="" || $h['width'] < "15"){
              	$width="50";
              
              }else{
              	$width=$h['width'];
              	
              }
            }
            //The column charactor width is converted to corrosponding pixel width
            $mycolumn->setAttribute('width', ($width * 6.27 + 12));
   		      $mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$h['header'].'</div>')); 
            $myhead->appendChild($mycolumn);
            unset ($mycolumn);
            $hix++;
          }
        } else {
          $mycolumn = $doc->createElement("column");
          $mycolumn->setAttribute('type', 'ro');
          $mycolumn->setAttribute('align', 'center');
          $mycolumn->setAttribute('sort', 'str');
          //$mycolumn->setAttribute('width', getArrayElements($widthArr,$hix));
          //TODO The following code should be modified to get the header width
          // as the minimum width if a width is not specified by user. WCD
          if (sizeof($widthArr)>0) { //User specified column widths are active
            $width=$widthArr[$key];
          }else{ //User not specified column widths so use header stuff
            if($h['width'] =="" || $h['width'] < "15"){
            	$width="50";          
            }else{
            	$width=$h['width'];
            }
          } 
          //The column charactor width is converted to corrosponding pixel width
          $mycolumn->setAttribute('width', ($width * 6.27 + 12));
  	      $mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$h['header'].'</div>')); 
          $myhead->appendChild($mycolumn);
          unset ($mycolumn);
          $hix++;
        }
  		}
    } // End of Header construction
    
    //$pk_grid=join("_",$pk); 
    $datarowHTML = '';
    for($i=($start+1);$i<=($start+$nnrows);$i++)
    {
      $pk_grid="";
      unset($pk_g);
      foreach($pk as $col){
      	$pk_g[] = $dataset[$i][$col];
      
      }
      
      $pk_grid=join("_",$pk_g);
      unset($pk_g);
      //var_dump($dataset[$i]);
      $sidx = 0; 
      $myrow = $doc->createElement("row");
      //$myrow->setAttribute('id',$dataset[$i][$pk]);
      $myrow->setAttribute('id',$pk_grid);
      $myrows->appendChild($myrow);
      
      foreach($dataset[$i] as $key=>$v)
      {
      	if(!(isset($v))){
      	 	$thisValue = '-';
      	}else {
      		$thisValue = $v;
        }
        if (is_array($colList)) {
          if (in_array($key,$colList)) {
            $mycell = $doc->createElement("cell");
            $mycell->setAttribute('style',getArrayElements($rowStylesArr,$sidx));
            $mycell->appendChild($doc->createTextNode(stripslashes($thisValue))); 
            $myrow->appendChild($mycell);
          }
        }else {
          $mycell = $doc->createElement("cell");
          $mycell->setAttribute('style',getArrayElements($rowStylesArr,$sidx));
          $mycell->appendChild($doc->createTextNode(stripslashes($thisValue))); 
          $myrow->appendChild($mycell);
        } 
        unset ($mycell,$thisValue);
        unset($pk_g);
        $pk_grid="";
      }
    	$sidx++;
      unset ($myrow);
      
    }
    $myXML=$doc->saveXML();
    //var_dump($myXML);
    return $myXML;
  }
} //-------------------End of  converDHTMLXGrid() -------------------

?>