<?php
/**************************************************************************************************************************
 *  This is a simple script to produce help text <ol> controller for JoyRider JQuery plug in.
 *  Additional informations can be found from this url http://www.zurb.com/playground/jquery-joyride-feature-tour-plugin
 *  Basic function of this script is accepting user data for <ol> content and outputting an html file with necessary JS code
 *  to function as a help file.
 *  
 *  Authour: Roshan (roshan@ekwa.com)
 *  Last modified: 14/02/2013
 *  
 */

if(isset($_REQUEST['sbtMakeFile'])){
	make_help_file();
}else{
	get_help_text_info();
}


/** 
 * This function accepts no parameters. It presents a form to accept information to define 
 * help text items.
 */
function get_help_text_info(){
	?>
	<html>
	<head>
	<title>Help file maker - 'Joy Ride JQuery Library'</title>
	<link rel="stylesheet" href="demo/demo-style.css">

	<script>
	function addHelpTipSegments(sel){

		var selVal = sel.value;
		var helpSegment = document.getElementById ('divHelpSegment');
		helpSegment.innerHTML = '';

		for(var i = 1; i<=selVal;i++){
		
			helpSegment.innerHTML = helpSegment.innerHTML +  
			'<fieldset>' +
			'<legend>Help Tip ' + i + '</legend>' +
			'<table style="border:0px solid black;width:111%">' +
			'<tr>' +
			'<td>' +
			'HTML element identification type:</td><td>'+
			'<select name="helpItem[' + i + '][selIdentity]" id="selIdentity-' + i + '">' +
			'<option value="id">Id</option>' +
			'<option value="class">Class</option></select>'+
			'</td>'+
			'</tr>'+

			'<tr>'+
			'<td>'+
			'HTML element identification name<br>(class name or id name):</td>'+
			'<td>'+
			'<input type="text" name="helpItem[' + i + '][txtIdName]" id="txtIdName-' + i + '">'+
			'</td>'+
			'</tr>'+

			'<tr>' +
			'<td>' +
			'HTML element help header:' +
			'</td>' +
			'<td>' +
			'<input type="text" name = "helpItem['+ i + '][txtHelpHeader]" id = "txtHelpHeader-' + i + '">' +
			'</td>' +
			'</tr>' +
			
			'<tr>'+
			'<td>'+
			'HTML element help text<br>(HTML elements can be included):</td>'+
			'<td>'+
			'<textarea name="helpItem[' + i + '][txthelpText]" id="txthelptext-' + i + '" rows=5 cols=111></textarea></td>'+
			'</tr>'+

			'<tr>'+
			'<td>'+
			'Button text:</td>'+
			'<td>'+
			'<input type="text" name="helpItem[' + i + '][txtButtonText]" id="txtButtonText-' + i + '">'+
			'</td>'+
			'</tr>'+

			'<tr>'+
			'<td>'+
			'Tip location:</td>'+
			'<td>'+
			'<select name="helpItem[' + i + '][setTipLocation]" id="setTipLocation-' + i + '">'+
			'<option value="top">Top</option>'+
			'<option value="bottom">Bottom</option>'+
			'<option value="left">Left</option>'+
			'<option value="right">Right</option>'+
			'</select>'+
			'</td>'+
			'</tr>'+
			'</table>'+
			'</fieldset>'+
			'<br><br>';
		}
	}
	</script>
	</head>
	<body style="margin-left: auto; margin: right:auto; padding-left: 51px; padding-right: 51px">
	<div style='text-align: right;width:200px;float:right;' ><a href="javascript:void(0)" id="divHowTo">How to use this tool</a></div>
	<h2>Help file maker</h2>
	<h4>A simple tool to make help tour files for your projects</h4>
	
	<form method="post" action="">
		<fieldset>
			<legend> Add Help Tip Information </legend>
			<table style="border: 0px solid black; width: 511px">
				<tr>
					<td>Help file name:</td>
					<td><input type="text" name="txtHelpFileName" id="txtHelpFileName">
					</td>
				</tr>

				<tr>
					<td>Help button/text id:</td>
					<td><input type="text" name="txtHelpButtonId" id="txtHelpButtonId">
					</td>
				</tr>

				<tr>
					<td>No of help tips for the file:</td>
					<td>
					<select id='selNoOfTip' name='selNoOfTip' onchange="addHelpTipSegments(this)">
						<?php 
						for($i=1;$i<21;$i++){
							echo '<option value="'.$i.'">'.$i.'</option>';
						}
						?>
					</select>
					</td>
				</tr>
			</table>
		</fieldset>

		<div id="divHelpSegment">
			<fieldset>
				<legend>Help Tip 1</legend>
				<table style="border:0px solid black;width:111%">
					<tr>
						<td>HTML element identification type:</td>
						<td><select name="helpItem[1][selIdentity]" id="selIdentity-1">
								<option value="id">Id</option>
								<option value="class">Class</option>
						</select>
						</td>
					</tr>

					<tr>
						<td>HTML element identification name<br>(class name or id name):
						</td>
						<td><input type="text" name="helpItem[1][txtIdName]"
							id="txtIdName-1">
						</td>
					</tr>

					<tr>
						<td>HTML element help header:</td>
						<td><input type="text" name="helpItem[1][txtHelpHeader]"
							id="txtHelpHeader-1">
						</td>
					</tr>
					
					<tr>
					<td>
						HTML element help text<br>(HTML elements can be included):</td>
					<td>
						<textarea name="helpItem[1][txthelpText]" id="txthelptext-1" rows=5 cols=111></textarea></td>
					</tr>
					
										
					<tr>
						<td>Button text:</td>
						<td><input type="text" name="helpItem[1][txtButtonText]"
							id="txtButtonText-1">
						</td>
					</tr>

					<tr>
					<td>Tip location:</td>
					<td><select name="helpItem[1][setTipLocation]"	id="setTipLocation-1">
							<option value="top">Top</option>
							<option value="bottom">Bottom</option>
							<option value="left">Left</option>
							<option value="right">Right</option>
					</select>
					</td>
					</tr>
				</table>
			</fieldset>
		</div>

		<br> <input type="submit" name="sbtMakeFile" value="Make Help File">
		</form>

	<?php 
	include('help_maker_tool_guide.php');
}//end of function




/**
 * This function will produce an heml file with supplied values obtained from get_help_text_info() function
 *  
 */
function make_help_file(){

	//var_dump($_REQUEST);

	$helpFileName = str_replace(' ', "_", $_REQUEST['txtHelpFileName']);
	$noOfItems = $_REQUEST['selNoOfTip'];
	$helpItems = $_REQUEST['helpItem'];
	$helpButtonId = $_REQUEST['txtHelpButtonId'];

	ob_start();
	?>
	<!-- FOR HELP TOUR -->
	<link rel="stylesheet" href="http://www.bizydads.com/frameworks/zurb-joyride-1d1cb89/joyride-2.0.3.css">
	
	<script type="text/javascript" src="http://www.bizydads.com/frameworks/zurb-joyride-1d1cb89/jquery-1.8.3.js"></script>
	<script type="text/javascript" src="http://www.bizydads.com/frameworks/zurb-joyride-1d1cb89/jquery.cookie.js"></script>
	<script type="text/javascript" src="http://www.bizydads.com/frameworks/zurb-joyride-1d1cb89/modernizr.mq.js"></script>
	<script type="text/javascript" src="http://www.bizydads.com/frameworks/zurb-joyride-1d1cb89/jquery.joyride-2.0.3.js"></script>

	<!-- Tip Content -->
	<ol id="joyRideTipContent">
		<?php 

		foreach($helpItems as $item){

			$dentityType = $item['selIdentity'];
			$identityName = $item['txtIdName'];
			$helpHeader = $item['txtHelpHeader'];
			$helpText = $item['txthelpText'];
			$buttonText = $item['txtButtonText'];
			$baloonLocation = $item['setTipLocation'];
			
			if(!empty($helpText)){
			?>
			<li data-<?php echo $dentityType?>="<?php echo $identityName?>" data-button="<?php echo $buttonText?>"	data-options="tipLocation:<?php echo $baloonLocation?>">
				<h2><?php echo $helpHeader?></h2>
				<p><?php echo $helpText?></p>
			</li>
			<?php 
			}//end if	
		}//end foreach

	?>
	</ol>
	<!-- End of tip contents -->

	<script>
	  $('#<?php echo $helpButtonId?>').click(function() {
          $('#joyRideTipContent').joyride({

              /***********************************************************************************
              
              // Following are options that is available to overide default
              // functionality of joyride plugin.You can uncomment and use them 
              // as you wish. for more information on this can be found at following location.
              // http://www.zurb.com/playground/jquery_joyride_feature_tour_plugin
              
              //***********************************************************************************
              
        	  'tipLocation': 'bottom',         // 'top' or 'bottom' in relation to parent
        	  'nubPosition': 'auto',           // override on a per tooltip bases
        	  'scrollSpeed': 300,              // Page scrolling speed in ms
        	  'timer': 2000,                   // 0 = off, all other numbers = time(ms) 
        	  'startTimerOnClick': true,       // true/false to start timer on first click
        	  'nextButton': true,              // true/false for next button visibility
        	  'tipAnimation': 'pop',           // 'pop' or 'fade' in each tip
        	  'pauseAfter': [],                // array of indexes where to pause the tour after
        	  'tipAnimationFadeSpeed': 300,    // if 'fade'- speed in ms of transition
        	  'cookieMonster': true,           // true/false for whether cookies are used
        	  'cookieName': 'JoyRide',         // choose your own cookie name
        	  'cookieDomain': false,           // set to false or yoursite.com
        	  'tipContainer': body,            // Where the tip be attached if not inline
        	  'postRideCallback': function(index,tip){ // a method to call once the tour closes

             },   
             postStepCallback : function (index, tip) {      // A method to call after each step
            	  
          	 }
          	 
           	 */        	  
            });//end of joyride
        });
	</script>

	<?php 
	$content = ob_get_contents();
	ob_end_clean();

	header("Content-Type: text/plain");
	header("Content-Disposition: attachment; filename=".$helpFileName.'.php');

	echo $content;



}//end of function


?>